
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Module readNplot &#8212; pyNumericalTrials 0.1.0 documentation</title>
    <link rel="stylesheet" href="_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <script id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <script src="_static/language_data.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="prev" title="Module executionManager" href="executionManager.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <div class="toctree-wrapper compound">
</div>
<div class="section" id="module-readnplot">
<h1>Module readNplot<a class="headerlink" href="#module-readnplot" title="Permalink to this headline">¶</a></h1>
<p>This module is used to read and plot data from the sql database contaning results.
Each result database is a finite representation of the function “compute_point” defining the numerical expierement:</p>
<p>compute_point: (arguments) -&gt; (results)</p>
<p>After an experiment has been performed, the fixed parameters are stored in the Experiments Database, the swept parameters are stored in the Results Database, along with the results which is a dictionary with nD-arrays for values.  Therefore, the results’ database implements the compute_point function with the fixed parameters partially applied:</p>
<p>result database: (location of database, swept arguments) -&gt; (results)</p>
<p>The result database does this, by assigning a unique “arg_id” to each unique combination of swept arguements in the database.
Then each table storying result database row refers to this arg_id.
Thus the database implements:</p>
<p>result database: (location of database, swept arguments) -&gt; arg_id -&gt; (results)</p>
<p>There are 3 types of tasks that this module</p>
<ol class="arabic simple">
<li><p>Functions for reading data in to a standard format.</p></li>
<li><p>A few standard plotting functions that also return the data they plot.</p></li>
<li><p>Functions for managing the swept arguments. For now these aren’t ready for use.</p></li>
</ol>
<p>Currently, this module is a bit of a mess, but there a few clean functions.
The most important is <a class="reference internal" href="#pyNumericalTrials.readNplot.get_results" title="pyNumericalTrials.readNplot.get_results"><code class="xref py py-func docutils literal notranslate"><span class="pre">pyNumericalTrials.readNplot.get_results()</span></code></a> which give you the disordered average dictonary that the function compute_point(args, datadir) produced.</p>
<div class="section" id="reading-data">
<h2>Reading data<a class="headerlink" href="#reading-data" title="Permalink to this headline">¶</a></h2>
<dl class="py function">
<dt id="pyNumericalTrials.readNplot.get_results">
<code class="sig-prename descclassname">pyNumericalTrials.readNplot.</code><code class="sig-name descname">get_results</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">loc</span></em>, <em class="sig-param"><span class="n">results_format</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.readNplot.get_results" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns results saved in results database at location loc</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>loc</strong> – location of results database</p></li>
<li><p><strong>results_format</strong> – shape of those keys, must match what is stored in results database</p></li>
</ul>
</dd>
</dl>
<dl class="simple">
<dt>Returns: (paramList, resultDictList)</dt><dd><p>paramList: list of dictonaires that describe the current swept parameter
resultDictList: list of result dictionaries with keys given by result_keys</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.readNplot.tracesFrom1DParamCut">
<code class="sig-prename descclassname">pyNumericalTrials.readNplot.</code><code class="sig-name descname">tracesFrom1DParamCut</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">loc</span></em>, <em class="sig-param"><span class="n">varParam</span></em>, <em class="sig-param"><span class="n">plotObs</span></em>, <em class="sig-param"><span class="n">fixedIndicies</span><span class="o">=</span><span class="default_value">[]</span></em>, <em class="sig-param"><span class="n">plotFrom</span><span class="o">=</span><span class="default_value">0</span></em>, <em class="sig-param"><span class="n">plotEvery</span><span class="o">=</span><span class="default_value">1</span></em>, <em class="sig-param"><span class="n">var_indicies</span><span class="o">=</span><span class="default_value">[]</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.readNplot.tracesFrom1DParamCut" title="Permalink to this definition">¶</a></dt>
<dd><p>reads 1D results specified by plotObs</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>loc</strong> – location of results database</p></li>
<li><p><strong>varParam</strong> – name of swept parameter indexing the results</p></li>
<li><p><strong>plotObs</strong> – name of results to read</p></li>
<li><p><strong>fixedIndicies</strong> – indicies of swept parameters that are kept constant</p></li>
<li><p><strong>var_indicies</strong> – list of indicies of parameters to vary in the legend if given overrides the following two parameters</p></li>
<li><p><strong>plotFrom</strong> – index of virst param being varied to plot</p></li>
<li><p><strong>plotEvery</strong> – indx = plotFrom + plotEvery*i</p></li>
</ul>
</dd>
</dl>
<dl class="simple">
<dt>Returns: (traces, varParamValues, fixedArgString)</dt><dd><p>traces: A dictionary with keys being the observable, and value being a list of 1D array, the order of the list is the same as the varParamsValues
varParamsValues: list of values taken by varParam indexing the list in the traces dictionary
fixedArgString: string describing fixed parameters</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.readNplot.getSweepInfo">
<code class="sig-prename descclassname">pyNumericalTrials.readNplot.</code><code class="sig-name descname">getSweepInfo</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">loc</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.readNplot.getSweepInfo" title="Permalink to this definition">¶</a></dt>
<dd><p>This function returns the swept parameters and their values for a database at loc</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>loc</strong> – location of result database</p>
</dd>
</dl>
<dl class="simple">
<dt>Returns: (sweptParams, uniqueParamValues)</dt><dd><ul class="simple">
<li><p>sweptParams: list of swept parameters</p></li>
<li><p>uniqueParamValues: dictionary of unique values for each parameter</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.readNplot.get_result">
<code class="sig-prename descclassname">pyNumericalTrials.readNplot.</code><code class="sig-name descname">get_result</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">loc</span></em>, <em class="sig-param"><span class="n">arg_id</span></em>, <em class="sig-param"><span class="n">results_format</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.readNplot.get_result" title="Permalink to this definition">¶</a></dt>
<dd><p>Gets results for specific arg_id</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>loc</strong> – location of result database</p></li>
<li><p><strong>arg_id</strong> – row in sweptArguments table</p></li>
<li><p><strong>results_format</strong> – shape of those keys, must match what is stored in results database</p></li>
</ul>
</dd>
</dl>
<dl class="simple">
<dt>Reutrns:</dt><dd><p>Dictionary with result_keys as keys and either a value,  a 1D array or 2D array depending on result_keys_format</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.readNplot.restructure2Dparams">
<code class="sig-prename descclassname">pyNumericalTrials.readNplot.</code><code class="sig-name descname">restructure2Dparams</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">paramList</span></em>, <em class="sig-param"><span class="n">resultList</span></em>, <em class="sig-param"><span class="n">xkey</span></em>, <em class="sig-param"><span class="n">ykey</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.readNplot.restructure2Dparams" title="Permalink to this definition">¶</a></dt>
<dd><p>This function takes the output of get_results and restuctures the results into a 2D array with the x and y dimention corresponding to the xkey and ykey respectively</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>paramList</strong> – list of dictionaries specifying arguments</p></li>
<li><p><strong>resultList</strong> – list of dictionaries of results</p></li>
<li><p><strong>xkey</strong> – key for x axis</p></li>
<li><p><strong>ykey</strong> – key for y axis</p></li>
</ul>
</dd>
</dl>
<dl class="simple">
<dt>Retuns:</dt><dd><p>reshaped: 2D array of results</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.readNplot.restructure3Dparams">
<code class="sig-prename descclassname">pyNumericalTrials.readNplot.</code><code class="sig-name descname">restructure3Dparams</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">paramList</span></em>, <em class="sig-param"><span class="n">resultList</span></em>, <em class="sig-param"><span class="n">xkey</span></em>, <em class="sig-param"><span class="n">ykey</span></em>, <em class="sig-param"><span class="n">zkey</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.readNplot.restructure3Dparams" title="Permalink to this definition">¶</a></dt>
<dd><p>This function takes the output of get_results and restuctures the results into a 3D array with the x, y and z dimention corresponding to the xkey, ykey and zkey respectively</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>paramList</strong> – list of dictionaries specifying arguments</p></li>
<li><p><strong>resultList</strong> – list of dictionaries of results</p></li>
<li><p><strong>xkey</strong> – key for x axis</p></li>
<li><p><strong>ykey</strong> – key for y axis</p></li>
<li><p><strong>zkey</strong> – key for z axis</p></li>
</ul>
</dd>
</dl>
<dl class="simple">
<dt>Retuns:</dt><dd><p>reshaped: 3D array of results</p>
</dd>
</dl>
</dd></dl>

</div>
<div class="section" id="plotting">
<h2>Plotting<a class="headerlink" href="#plotting" title="Permalink to this headline">¶</a></h2>
<dl class="py function">
<dt id="pyNumericalTrials.readNplot.phaseDiagram">
<code class="sig-prename descclassname">pyNumericalTrials.readNplot.</code><code class="sig-name descname">phaseDiagram</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">loc</span></em>, <em class="sig-param"><span class="n">result_key</span></em>, <em class="sig-param"><span class="n">key_type</span><span class="o">=</span><span class="default_value">0</span></em>, <em class="sig-param"><span class="n">label</span><span class="o">=</span><span class="default_value">''</span></em>, <em class="sig-param"><span class="n">time</span><span class="o">=</span><span class="default_value">- 1</span></em>, <em class="sig-param"><span class="n">average</span><span class="o">=</span><span class="default_value">False</span></em>, <em class="sig-param"><span class="n">fixed</span><span class="o">=</span><span class="default_value">{}</span></em>, <em class="sig-param"><span class="n">cmap</span><span class="o">=</span><span class="default_value">'viridis'</span></em>, <em class="sig-param"><span class="n">log</span><span class="o">=</span><span class="default_value">False</span></em>, <em class="sig-param"><span class="n">yscale</span><span class="o">=</span><span class="default_value">1</span></em>, <em class="sig-param"><span class="n">ax</span><span class="o">=</span><span class="default_value">- 1</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.readNplot.phaseDiagram" title="Permalink to this definition">¶</a></dt>
<dd><p>This function produces a 2D phase diagram color plot for a 0D result key, and a sweep that has exactly two swept parameters.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>loc</strong> – location of results database</p></li>
<li><p><strong>result_key</strong> – result key for a 0D result</p></li>
</ul>
</dd>
</dl>
<dl class="simple">
<dt>Returns: (XS, YS, Zs)</dt><dd><ul class="simple">
<li><p>XS: 2D array for X variables</p></li>
<li><p>YS: 2D array for Y variables</p></li>
<li><p>Zs: 2D array for 0D result varable</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.readNplot.traceLegendParams">
<code class="sig-prename descclassname">pyNumericalTrials.readNplot.</code><code class="sig-name descname">traceLegendParams</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">loc</span></em>, <em class="sig-param"><span class="n">varParam</span></em>, <em class="sig-param"><span class="n">plotObs</span></em>, <em class="sig-param"><span class="n">fixedIndicies</span><span class="o">=</span><span class="default_value">[]</span></em>, <em class="sig-param"><span class="n">plotFrom</span><span class="o">=</span><span class="default_value">0</span></em>, <em class="sig-param"><span class="n">plotEvery</span><span class="o">=</span><span class="default_value">1</span></em>, <em class="sig-param"><span class="n">dt</span><span class="o">=</span><span class="default_value">1</span></em>, <em class="sig-param"><span class="n">log</span><span class="o">=</span><span class="default_value">False</span></em>, <em class="sig-param"><span class="n">logy</span><span class="o">=</span><span class="default_value">False</span></em>, <em class="sig-param"><span class="n">loglog</span><span class="o">=</span><span class="default_value">False</span></em>, <em class="sig-param"><span class="n">fit</span><span class="o">=</span><span class="default_value">False</span></em>, <em class="sig-param"><span class="n">saveName</span><span class="o">=</span><span class="default_value">'NOPLOT'</span></em>, <em class="sig-param"><span class="n">title</span><span class="o">=</span><span class="default_value">''</span></em>, <em class="sig-param"><span class="n">xlabel</span><span class="o">=</span><span class="default_value">'t'</span></em>, <em class="sig-param"><span class="n">var_indicies</span><span class="o">=</span><span class="default_value">[]</span></em>, <em class="sig-param"><span class="n">legend</span><span class="o">=</span><span class="default_value">True</span></em>, <em class="sig-param"><span class="n">plot</span><span class="o">=</span><span class="default_value">True</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.readNplot.traceLegendParams" title="Permalink to this definition">¶</a></dt>
<dd><p>This function produces a multiple plots for a 1D result, with different values of the varParam in the legend and different plots corresponding to different observalbes.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>loc</strong> – location of results database</p></li>
<li><p><strong>varParam</strong> – parameter to vary in the legend</p></li>
<li><p><strong>plotObs</strong> – list of result key for a 1D result: [“key1”, “key2”]</p></li>
<li><p><strong>fixedIndicies</strong> – list of indicies of parameters to fix</p></li>
<li><p><strong>dt</strong> – how to scale x axis of figure.  x = np.array(range(len(trace)))*dt</p></li>
<li><p><strong>log</strong> – whether to plot semilogx</p></li>
<li><p><strong>logy</strong> – whether to plot semilogy</p></li>
<li><p><strong>loglog</strong> – whether to plot loglog</p></li>
<li><p><strong>fit</strong> – whether to fit a curve to the data</p></li>
<li><p><strong>saveName</strong> – name of file to save figure to (default NOPLOT means it doesn’t save a figure)</p></li>
<li><p><strong>title</strong> – title of figure</p></li>
<li><p><strong>xlabel</strong> – label for x axis</p></li>
<li><p><strong>var_indicies</strong> – list of indicies of parameters to vary in the legend if given overrides the following two parameters</p></li>
<li><p><strong>plotFrom</strong> – index of virst param being varied to plot</p></li>
<li><p><strong>plotEvery</strong> – indx = plotFrom + plotEvery*i</p></li>
<li><p><strong>legend</strong> – whether to plot a legend</p></li>
<li><p><strong>plot</strong> – whether to plot the figure or just return data</p></li>
</ul>
</dd>
</dl>
<dl class="simple">
<dt>Returns: (traces, varParamList)</dt><dd><ul class="simple">
<li><p>traces: A dictionary with keys being the observable, and value being a list of 1D array, the order of the list is the same as the varParamsValues</p></li>
<li><p>varParamsValues: list of values taken by varParam in the legend/database</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.readNplot.timecut">
<code class="sig-prename descclassname">pyNumericalTrials.readNplot.</code><code class="sig-name descname">timecut</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">loc</span></em>, <em class="sig-param"><span class="n">varParam</span></em>, <em class="sig-param"><span class="n">plotObs</span></em>, <em class="sig-param"><span class="n">time</span></em>, <em class="sig-param"><span class="n">average</span><span class="o">=</span><span class="default_value">False</span></em>, <em class="sig-param"><span class="n">fixedIndicies</span><span class="o">=</span><span class="default_value">[]</span></em>, <em class="sig-param"><span class="n">plotFrom</span><span class="o">=</span><span class="default_value">0</span></em>, <em class="sig-param"><span class="n">plotEvery</span><span class="o">=</span><span class="default_value">1</span></em>, <em class="sig-param"><span class="n">dt</span><span class="o">=</span><span class="default_value">1</span></em>, <em class="sig-param"><span class="n">log</span><span class="o">=</span><span class="default_value">False</span></em>, <em class="sig-param"><span class="n">logy</span><span class="o">=</span><span class="default_value">False</span></em>, <em class="sig-param"><span class="n">loglog</span><span class="o">=</span><span class="default_value">False</span></em>, <em class="sig-param"><span class="n">fit</span><span class="o">=</span><span class="default_value">False</span></em>, <em class="sig-param"><span class="n">saveName</span><span class="o">=</span><span class="default_value">'NOPLOT'</span></em>, <em class="sig-param"><span class="n">title</span><span class="o">=</span><span class="default_value">''</span></em>, <em class="sig-param"><span class="n">xlabel</span><span class="o">=</span><span class="default_value">'t'</span></em>, <em class="sig-param"><span class="n">var_indicies</span><span class="o">=</span><span class="default_value">[]</span></em>, <em class="sig-param"><span class="n">plot</span><span class="o">=</span><span class="default_value">True</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.readNplot.timecut" title="Permalink to this definition">¶</a></dt>
<dd><p>This function plots time cuts or averages v.s. the varParam.
It has the same functionality as traceLegendParams, but it plots time cuts instead of traces.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>time</strong> – time to cut at or average after</p></li>
<li><p><strong>average</strong> – whether to average or not</p></li>
</ul>
</dd>
</dl>
<dl class="simple">
<dt>Returns: (cutvalues, varParamsvalues)</dt><dd><p>cutvalues: A dictionary with keys being the observable, and value being a list of 1D array, the order of the list is the same as the varParamsValues
varParamsValues: list of values taken by varParam in the x-axis of plot</p>
</dd>
</dl>
</dd></dl>

</div>
</div>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="index.html">pyNumericalTrials</a></h1>








<h3>Navigation</h3>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="trialManager.html">Module trialManager</a></li>
<li class="toctree-l1"><a class="reference internal" href="executionManager.html">Module executionManager</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Module readNplot</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#reading-data">Reading data</a></li>
<li class="toctree-l2"><a class="reference internal" href="#plotting">Plotting</a></li>
</ul>
</li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="index.html">Documentation overview</a><ul>
      <li>Previous: <a href="executionManager.html" title="previous chapter">Module executionManager</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2021, Shane P. Kelly.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 3.2.1</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="_sources/readNplot.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>